﻿using UnityEngine;
using System.Collections;

public class ElementScript : MonoBehaviour {

    public bool selected = false;
    public float alpha = 1.0f;
    public bool alphaDecreasing = true;
    public float minAlpha = 0.75f;

    public float timerAlpha = 0.3f;
    public bool timerAlphaEnabled = true;

    public int posX;
    public int posY;

    public int moveHorizontal = 0;
    public int moveVertical = 0;
    public int moveDiagonal = 0;

    public int player;

    public bool moving = false;
    public float moveX;
    public float moveY;

    public bool won = false;

    public string element;

    public bool movingWin = false;
    int timesWon = 0;

	void Start () {
        setMovingDirections();
	}

    void setMovingDirections() {
        if (this.name.Substring(0, 8) == "CharFire") {
            moveHorizontal = 2;
            moveVertical = 2;
            moveDiagonal = 1;
            element = "Fire";
        } else if (this.name.Substring(0, 9) == "CharWater") {
            moveHorizontal = 2;
            moveVertical = 2;
            moveDiagonal = 1;
            element = "Water";
        } else {
            moveHorizontal = 2;
            moveVertical = 2;
            moveDiagonal = 1;
            element = "Earth";
        }
    }
	
	void Update () {

        if (movingWin) {
            if (moveX > this.transform.position.x)
            {
                transform.position = new Vector3(transform.position.x + 1, transform.position.y, 0);
            }
            else if (moveX < this.transform.position.x)
            {
                transform.position = new Vector3(transform.position.x - 1, transform.position.y, 0);
            }

            if (moveY > this.transform.position.y)
            {
                transform.position = new Vector3(transform.position.x, transform.position.y + 1, 0);
            }
            else if (moveY < this.transform.position.y)
            {
                transform.position = new Vector3(transform.position.x, transform.position.y - 1, 0);
            }

            if (transform.position.x == moveX && transform.position.y == moveY)
            {
                movingWin = false;
                timesWon++;

                if (timesWon >= 2 && element == "Fire") {

                    SpriteRenderer renderer = GetComponent<SpriteRenderer>();

                    renderer.sprite = (Sprite)Resources.Load("Sprites/avatar", typeof(Sprite)) as Sprite;

                    moveX = -3;
                    moveY = 193;
                    movingWin = true;
                }

                if (timesWon >= 3) {
                    Application.LoadLevel(0);
                }
            }
        }

        if (moving) {
            if (moveX > this.transform.position.x) {
                transform.position = new Vector3(transform.position.x + 1, transform.position.y, 0);
            } else if (moveX < this.transform.position.x) {
                transform.position = new Vector3(transform.position.x - 1, transform.position.y, 0);
            }

            if (moveY > this.transform.position.y) {
                transform.position = new Vector3(transform.position.x, transform.position.y + 1, 0);
            } else if (moveY < this.transform.position.y) {
                transform.position = new Vector3(transform.position.x, transform.position.y - 1, 0);
            }

            if (transform.position.x == moveX && transform.position.y == moveY){
                moving = false;
                GameScript.isMoving = false;
				dismissMist();
                checkIfIsInMiddle();
                checkWhatTile();
                GameScript.endTurn();
            }
        }

        if (selected) {
            if (timerAlphaEnabled) {
                timerAlpha -= 0.01f;

                if (timerAlpha <= 0) {
                    timerAlphaEnabled = false;
                    timerAlpha = 0.3f;
                }

                return;
            }

            if (alphaDecreasing){
                alpha -= 0.01f;
                if (alpha <= minAlpha){
                    alphaDecreasing = false;
                    timerAlphaEnabled = true;
                }
            } else {
                alpha += 0.01f;

                if (alpha >= 1.0f){
                    alphaDecreasing = true;
                    timerAlphaEnabled = true;
                }
            }

            Functions.setSpriteAlpha(this.gameObject, alpha);
        }
	}

	void dismissMist(){
		if (GameScript.arrayMistCount > 0){
			for (int i = 0; i < GameScript.arrayMistCount; i++){
				GameScript.tilesScripts[GameScript.arrayMistX[i], GameScript.arrayMistY[i]].show();
			}
		}

		GameScript.arrayMistX = new int[50];
		GameScript.arrayMistY = new int[50];
		GameScript.arrayMistCount = 0;
	}

    void checkWhatTile() {
        foreach (TilesScript tile in GameScript.tilesScripts) {
            if (posX == tile.posX && posY == tile.posY) {
                switch (interactionBetweenElements(element, tile.element)) {
                    case -1: //Lost
                        GameObject.Find("soundBad").GetComponent<AudioSource>().Play();
                        if (GameScript.playerTurn == 1) {
                            int iterations = Functions.getRandomInt(1, 4);

                            for (int i = 0; i < iterations; i++) {
                                bool tileSelected = false;

                                while (tileSelected == false) {
									int tilePosX = Functions.getRandomInt(GameScript.nCols / 2 + 1, GameScript.nCols - 1);
                                    int tilePosY = Functions.getRandomInt(0, GameScript.nRows - 1);
									
                                    if (GameScript.tilesScripts[tilePosX, tilePosY].hidden == true) {
                                        GameScript.tilesScripts[tilePosX, tilePosY].show();
                                        tileSelected = true;
                                    }
                                }
                            }
                        } else {
                            int iterations = Functions.getRandomInt(1, 4);

                            for (int i = 0; i < iterations; i++) {
                                bool tileSelected = false;

                                while (tileSelected == false) {
                                    int tilePosX = Functions.getRandomInt(0, GameScript.nCols / 2 - 2);
                                    int tilePosY = Functions.getRandomInt(0, GameScript.nRows - 1);

                                    if (GameScript.tilesScripts[tilePosX, tilePosY].hidden == true) {
                                        GameScript.tilesScripts[tilePosX, tilePosY].show();
                                        tileSelected = true;
                                    }
                                }
                            }
                        }
                        break;
                    case 0: //Neutral
                        GameObject.Find("soundNeutral").GetComponent<AudioSource>().Play();
                        break;
                    case 1: //Won
                        GameObject.Find("soundGood").GetComponent<AudioSource>().Play();
                        if (GameScript.playerTurn == 2){
                            int iterations = Functions.getRandomInt(1, 4);

                            for (int i = 0; i < iterations; i++){
                                bool tileSelected = false;

                                while (tileSelected == false){
									int tilePosX = Functions.getRandomInt(0, GameScript.nCols / 2 - 2);
									int tilePosY = Functions.getRandomInt(0, GameScript.nRows - 1);

                                    if (GameScript.tilesScripts[tilePosX, tilePosY].hidden == true){
                                        GameScript.tilesScripts[tilePosX, tilePosY].show();
                                        tileSelected = true;
                                    }
                                }
                            }
                        }else{
                            int iterations = Functions.getRandomInt(1, 4);

                            for (int i = 0; i < iterations; i++){
                                bool tileSelected = false;

                                while (tileSelected == false){
									int tilePosX = Functions.getRandomInt(GameScript.nCols / 2 + 1, GameScript.nCols - 1);
									int tilePosY = Functions.getRandomInt(0, GameScript.nRows - 1);

                                    if (GameScript.tilesScripts[tilePosX, tilePosY].hidden == true){
                                        GameScript.tilesScripts[tilePosX, tilePosY].show();
                                        tileSelected = true;
                                    }
                                }
                            }
                        }
                        break;
                    case 2: //Same Element
                        GameObject.Find("soundGood").GetComponent<AudioSource>().Play();
                        GameScript.extraTurn = true;
                        GameScript.extraElement = this;
                        break;
                    case 3: //PowerUp Inspection
                        GameObject.Find("soundPowerUp").GetComponent<AudioSource>().Play();
						if (posX - 1 >= 0 && posY -1 >= 0)
                        	GameScript.tilesScripts[posX - 1, posY - 1].show();
						if (posX - 1 >= 0)
                        GameScript.tilesScripts[posX - 1, posY].show();
						if (posX - 1 >= 0 && posY + 1 < GameScript.nRows)
                        GameScript.tilesScripts[posX - 1, posY + 1].show();
						if(posY - 1 > 0)
                        GameScript.tilesScripts[posX, posY - 1].show();
						if(posY + 1 < GameScript.nRows)
                        GameScript.tilesScripts[posX, posY + 1].show();
						if (posX + 1 < GameScript.nCols && posY -1 >= 0)
                        GameScript.tilesScripts[posX + 1, posY - 1].show();
						if (posX + 1 < GameScript.nCols)
                        GameScript.tilesScripts[posX + 1, posY].show();
						if (posX + 1 < GameScript.nCols && posY +1 < GameScript.nRows)
                        GameScript.tilesScripts[posX + 1, posY + 1].show();

						GameScript.tilesScripts[posX, posY].element = "Neutral";
						if (posX <= GameScript.nCols / 2){
							Functions.setSpriteAlpha(GameScript.pUpInspection1, 0.0f);
						} else {
							Functions.setSpriteAlpha(GameScript.pUpInspection2, 0.0f);    
						}
						break;
				case 4: //PowerUp Mist
                        GameObject.Find("soundPowerUp").GetComponent<AudioSource>().Play();
					if (GameScript.playerTurn == 2){
						for (int i = 0; i < GameScript.nRows; i++){
							for (int j = 0; j < GameScript.nCols / 2 - 1; j++){
								if (!GameScript.tilesScripts[j, i].hidden){
									GameScript.arrayMistX[GameScript.arrayMistCount] = j;
									GameScript.arrayMistY[GameScript.arrayMistCount] = i;

									GameScript.arrayMistCount++;

									GameScript.tilesScripts[j, i].hide();
								}
							}
						}
					} else {
						for (int i = 0; i < GameScript.nRows; i++){
							for (int j = GameScript.nCols / 2 + 1; j < GameScript.nCols; j++){
								if (!GameScript.tilesScripts[j, i].hidden){
									GameScript.arrayMistX[GameScript.arrayMistCount] = j;
									GameScript.arrayMistY[GameScript.arrayMistCount] = i;
									
									GameScript.arrayMistCount++;
									
									GameScript.tilesScripts[j, i].hide();
								}
							}
						}
					}

					GameScript.tilesScripts[posX, posY].element = "Neutral";
					if (posX <= GameScript.nCols / 2){
						Functions.setSpriteAlpha(GameScript.pUpMist1, 0.0f);
					} else {
						Functions.setSpriteAlpha(GameScript.pUpMist2, 0.0f);    
					}
					break;
				case 5: //PowerUp Observer
                    GameObject.Find("soundPowerUp").GetComponent<AudioSource>().Play();
					if (GameScript.playerTurn == 1){
						for (int i = 0; i < GameScript.nRows; i++){
							for (int j = 0; j < GameScript.nCols / 2 - 1; j++){
								if (GameScript.tilesScripts[j, i].hidden){
									GameScript.arrayObserverX[GameScript.arrayObserverCount] = j;
									GameScript.arrayObserverY[GameScript.arrayObserverCount] = i;
									
									GameScript.arrayObserverCount++;
									
									GameScript.tilesScripts[j, i].show();

                                    GameScript.tilesScripts[j, i].hidden = true;
								}
							}
						}
					} else {
						for (int i = 0; i < GameScript.nRows; i++){
							for (int j = GameScript.nCols / 2 + 1; j < GameScript.nCols; j++){
								if (GameScript.tilesScripts[j, i].hidden){
									GameScript.arrayObserverX[GameScript.arrayObserverCount] = j;
									GameScript.arrayObserverY[GameScript.arrayObserverCount] = i;
									
									GameScript.arrayObserverCount++;
									
									GameScript.tilesScripts[j, i].show();

                                    GameScript.tilesScripts[j, i].hidden = true;
								}
							}
						}
					}
					
					GameScript.tilesScripts[posX, posY].element = "Neutral";
					if (posX <= GameScript.nCols / 2){
						Functions.setSpriteAlpha(GameScript.pUpObserver1, 0.0f);
					} else {
						Functions.setSpriteAlpha(GameScript.pUpObserver2, 0.0f);    
					}
					break;
				case 6: //PowerUp Tornado
                    GameObject.Find("soundPowerUp").GetComponent<AudioSource>().Play();
					if (GameScript.playerTurn == 2){
						for (int i = 0; i < GameScript.nRows; i++){
							for (int j = 0; j < GameScript.nCols / 2 - 1; j++){
								if (!GameScript.tilesScripts[j, i].hidden &&
								    GameScript.tilesScripts[j, i].element != "Inspector" &&
								    GameScript.tilesScripts[j, i].element != "Mist" &&
								    GameScript.tilesScripts[j, i].element != "Observer" &&
								    GameScript.tilesScripts[j, i].element != "Tornado" &&
								    GameScript.tilesScripts[j, i].element != "Holes"){
									int rnd = Functions.getRandomInt(1,4);

									GameScript.changeTile(j, i, rnd);
								}
							}
						}
					} else {
						for (int i = 0; i < GameScript.nRows; i++){
							for (int j = GameScript.nCols / 2 + 1; j < GameScript.nCols; j++){
								if (!GameScript.tilesScripts[j, i].hidden &&
								    GameScript.tilesScripts[j, i].element != "Inspector" &&
								    GameScript.tilesScripts[j, i].element != "Mist" &&
								    GameScript.tilesScripts[j, i].element != "Observer" &&
								    GameScript.tilesScripts[j, i].element != "Tornado" &&
								    GameScript.tilesScripts[j, i].element != "Stone"){
									int rnd = Functions.getRandomInt(1,4);

                                    GameScript.changeTile(j, i, rnd);
								}
							}
						}
					}

					GameScript.tilesScripts[posX, posY].element = "Neutral";
					if (posX <= GameScript.nCols / 2){
						Functions.setSpriteAlpha(GameScript.pUpTornado1, 0.0f);
					} else {
						Functions.setSpriteAlpha(GameScript.pUpTornado2, 0.0f);    
					}
					break;
				case 7: //PowerUp Stone
                    GameObject.Find("soundPowerUp").GetComponent<AudioSource>().Play();
					for (int i = 0; i < 2; i++){
						int posX2 = Functions.getRandomInt(1, GameScript.nCols / 2 - 2);
						int posY2 = Functions.getRandomInt(0, GameScript.nRows - 1);

                        GameScript.changeTile(posX2, posY2, 6);
						GameScript.tilesScripts[posX2, posY2].show();
						
						posX2 = Functions.getRandomInt(GameScript.nCols / 2 + 1, GameScript.nCols - 2);
						posY2 = Functions.getRandomInt(0, GameScript.nRows - 1);

                        GameScript.changeTile(posX2, posY2, 6);
						GameScript.tilesScripts[posX2, posY2].show();
					}

					GameScript.tilesScripts[posX, posY].element = "Neutral";
					if (posX <= GameScript.nCols / 2){
						Functions.setSpriteAlpha(GameScript.pUpStone1, 0.0f);
					} else {
						Functions.setSpriteAlpha(GameScript.pUpStone2, 0.0f);    
					}
					break;
                }
            }
        }
    }

    int interactionBetweenElements(string element1, string element2) {
        if (element2 == "Inspection") {
			GameScript.msgInspector.display();

            return 3;
        }

		if (element2 == "Mist"){
			GameScript.msgMist.display();

			return 4;
		}

		if (element2 == "Observer"){
			GameScript.msgObserver.display();

			return 5;
		}

		if (element2 == "Tornado"){
			GameScript.msgTornado.display();

			return 6;
		}

		if (element2 == "Stone"){
			GameScript.msgStone.display();

			return 7;
		}

        if (element1 == element2) {
			GameScript.msgMoveAgain.display();

            return 2;
        }

        if ((element1 == "Fire" && element2 == "Water") || (element1 == "Water" && element2 == "Earth") || (element1 == "Earth" && element2 == "Fire")) {
			if (element1 == "Fire") GameScript.msgWaterVsFire.display();
			if (element1 == "Water") GameScript.msgEarthVsWater.display();
			if (element1 == "Earth") GameScript.msgFireVsEarth.display();

			return -1;
        }

        if ((element1 == "Fire" && element2 == "Earth") || (element1 == "Water" && element2 == "Fire") || (element1 == "Earth" && element2 == "Water")) {
			if (element1 == "Fire") GameScript.msgFireVsEarth.display();
			if (element1 == "Water") GameScript.msgWaterVsFire.display();
			if (element1 == "Earth") GameScript.msgEarthVsWater.display();

			return 1;
        }

        return 0;
    }

    void checkIfIsInMiddle() {
        if (posX == GameScript.nCols / 2 - 1 || posX == GameScript.nCols / 2) {
            won = true;

            moveToMiddle();
        }
    }

    public void setSelected(bool boolSelected) {
        if (GameScript.scriptSelected == null) {
            GameScript.scriptSelected = this;
        } else if (GameScript.scriptSelected != this) {
            GameScript.scriptSelected.setSelected(false);
            GameScript.scriptSelected = this;
        }
        
        selected = boolSelected;

        if (selected) {
            resetHighlightedTiles();
            highlightMovableTiles();
        } else {
            Functions.highlightSprite(this.gameObject, "Normal");
            Functions.setSpriteAlpha(this.gameObject, 1.0f);
        }
    }

    void resetHighlightedTiles() {
        foreach (TilesScript tile in GameScript.tilesScripts){
            tile.setSelected(false);
        }
    }

    void highlightMovableTiles() {
        for (int i = 0; i < GameScript.nRows; i++) {
            for (int j = 0; j < GameScript.nCols; j++) {

                if (j == posX && i == posY && GameScript.tilesScripts[j, i].element != "Wall") {
                    for (int k = 1; k <= moveHorizontal; k++) {
                        if (player == 1) {
                            GameScript.tilesScripts[posX + k, posY].setSelected(true);
                        } else {
                            GameScript.tilesScripts[posX - k, posY].setSelected(true);
                        }
                    }

                    for (int k = 1; k <= moveVertical; k++) {
                        if (posY + k < GameScript.nRows) {
                            GameScript.tilesScripts[posX, posY + k].setSelected(true);
                        }

                        if (posY - k >= 0) {
                            GameScript.tilesScripts[posX, posY - k].setSelected(true);
                        }
                    }

                    for (int k = 1; k <= moveDiagonal; k++) {
                        if (player == 1) {
                            if (posY + k < GameScript.nRows) {
                                GameScript.tilesScripts[posX + k, posY + k].setSelected(true);
                            }

                            if (posX + k < GameScript.nCols && posY - k >= 0) {
                                GameScript.tilesScripts[posX + k, posY - k].setSelected(true);
                            }
                        } else {
                            if (posY + k < GameScript.nRows) {
                                GameScript.tilesScripts[posX - k, posY + k].setSelected(true);
                            }

                            if (posY - k >= 0) {
                                GameScript.tilesScripts[posX - k, posY - k].setSelected(true);
                            }
                        }
                    }

                    GameScript.tilesScripts[posX, posY].setSelected(true);
                    GameScript.tilesScripts[posX, posY].setSuperSelected(true);
                }
            }
        }
    }

    public void goUp() {
        if (GameScript.selectedTile.posY - 1 >= 0 && GameScript.tilesScripts[GameScript.selectedTile.posX, GameScript.selectedTile.posY - 1].selected) {
            GameScript.tilesScripts[GameScript.selectedTile.posX, GameScript.selectedTile.posY - 1].setSuperSelected(true);
            return;
        }

        if (GameScript.selectedTile.posX + 1 < GameScript.nCols && GameScript.selectedTile.posY - 1 >= 0) {
            if (GameScript.tilesScripts[GameScript.selectedTile.posX + 1, GameScript.selectedTile.posY - 1].selected){
                GameScript.tilesScripts[GameScript.selectedTile.posX + 1, GameScript.selectedTile.posY - 1].setSuperSelected(true);
                return;
            }
        }

        if (GameScript.selectedTile.posX - 1 >= 0 && GameScript.selectedTile.posY -1 >= 0 && GameScript.tilesScripts[GameScript.selectedTile.posX - 1, GameScript.selectedTile.posY - 1].selected) {
            GameScript.tilesScripts[GameScript.selectedTile.posX - 1, GameScript.selectedTile.posY - 1].setSuperSelected(true);
            return;
        }
    }

    public void goLeft() {
        if (GameScript.tilesScripts[GameScript.selectedTile.posX - 1, GameScript.selectedTile.posY].selected){
            GameScript.tilesScripts[GameScript.selectedTile.posX - 1, GameScript.selectedTile.posY].setSuperSelected(true);
        }
    }

    public void goDown(){
        if (GameScript.tilesScripts[GameScript.selectedTile.posX, GameScript.selectedTile.posY + 1].selected){
            GameScript.tilesScripts[GameScript.selectedTile.posX, GameScript.selectedTile.posY + 1].setSuperSelected(true);
            return;
        }

        if (GameScript.tilesScripts[GameScript.selectedTile.posX + 1, GameScript.selectedTile.posY + 1].selected) {
            GameScript.tilesScripts[GameScript.selectedTile.posX + 1, GameScript.selectedTile.posY + 1].setSuperSelected(true);
            return;
        }

        if (GameScript.tilesScripts[GameScript.selectedTile.posX - 1, GameScript.selectedTile.posY + 1].selected) {
            GameScript.tilesScripts[GameScript.selectedTile.posX - 1, GameScript.selectedTile.posY + 1].setSuperSelected(true);
            return;
        }
    }

    public void goRight(){
        if (GameScript.tilesScripts[GameScript.selectedTile.posX + 1, GameScript.selectedTile.posY].selected){
            GameScript.tilesScripts[GameScript.selectedTile.posX + 1, GameScript.selectedTile.posY].setSuperSelected(true);
        }
    }

    public void moveToSelected() {
		if (GameScript.selectedTile.element == "Wall") return;

        moving = true;
        moveX = GameScript.selectedTile.transform.position.x;
        moveY = GameScript.selectedTile.transform.position.y - GameScript.charOffsetY;

        posX = GameScript.selectedTile.posX;
        posY = GameScript.selectedTile.posY;

        GameScript.isMoving = true;

        GameScript.selectedTile.show();

		resetHighlightedTiles();

		if (GameScript.selectedTile.element == "Inspection"){
			if (GameScript.playerTurn == 1){
				Functions.setSpriteAlpha(GameScript.pUpInspection1, 1.0f);
			} else {
				Functions.setSpriteAlpha(GameScript.pUpInspection2, 1.0f);
			}
		}
    }

    void moveToMiddle() {
        if (element == "Fire") {
            moveX = -3;
            moveY = 193;

            movingWin = true;
        }

        if (element == "Water") {
            moveX = -3;
            moveY = -173;

            movingWin = true;
        }

        if (element == "Earth"){
            moveX = -4;
            moveY = -140;

            movingWin = true;
        }

    }
}
