﻿using UnityEngine;
using System.Collections;

public class TilesScript : MonoBehaviour {

    public bool selected = false;
    public bool superSelected = false;

    public int posX;
    public int posY;

    public string element;
    public bool hidden = true;

    bool trans = false;
    bool decreasing = true;
    float alpha = 1.0f;

	void Start () {
	
	}
	
	void Update () {
        if (trans) {
            if (decreasing) {
                alpha -= 0.04f;

                Functions.setSpriteAlpha(gameObject, alpha);

                if (alpha <= 0) {
                    decreasing = false;
                    SpriteRenderer renderer = this.GetComponent<SpriteRenderer>();

                    switch (element) {
                        case "Neutral":
                            renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
                            break;
                        case "Fire":
                            renderer.sprite = (Sprite)Resources.Load(Paths.tileFire, typeof(Sprite)) as Sprite;
                            break;
                        case "Water":
                            renderer.sprite = (Sprite)Resources.Load(Paths.tileWater, typeof(Sprite)) as Sprite;
                            break;
                        case "Earth":
                            renderer.sprite = (Sprite)Resources.Load(Paths.tileEarth, typeof(Sprite)) as Sprite;
                            break;
                        case "Wall":
                            renderer.sprite = (Sprite)Resources.Load(Paths.tileWall, typeof(Sprite)) as Sprite;
                            break;
                    }
                }
            } else {
                alpha += 0.04f;

                Functions.setSpriteAlpha(gameObject, alpha);

                if (alpha >= 1) {
                    decreasing = true;
                    trans = false;
                }
            }
        }    
	}

    public void hide() {
        SpriteRenderer renderer = this.GetComponent<SpriteRenderer>();

        renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden, typeof(Sprite)) as Sprite;

        hidden = true;
    }

    public void show() {
        SpriteRenderer renderer = this.GetComponent<SpriteRenderer>();
        hidden = false;

        setTransition();

        switch (element) {
			case "Inspection":
				renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
				if (posX <= GameScript.nCols / 2 - 1){
					Functions.setSpriteAlpha(GameScript.pUpInspection1, 1.0f);
				} else {
					Functions.setSpriteAlpha(GameScript.pUpInspection2, 1.0f);
				}
				break;
			case "Mist":
				renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
				if (posX <= GameScript.nCols / 2 - 1){
					Functions.setSpriteAlpha(GameScript.pUpMist1, 1.0f);
				} else {
					Functions.setSpriteAlpha(GameScript.pUpMist2, 1.0f);
				}
				break;
			case "Observer":
				renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
				if (posX <= GameScript.nCols / 2 - 1){
					Functions.setSpriteAlpha(GameScript.pUpObserver1, 1.0f);
				} else {
					Functions.setSpriteAlpha(GameScript.pUpObserver2, 1.0f);
				}
				break;
			case "Tornado":
				renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
				if (posX <= GameScript.nCols / 2 - 1){
					Functions.setSpriteAlpha(GameScript.pUpTornado1, 1.0f);
				} else {
					Functions.setSpriteAlpha(GameScript.pUpTornado2, 1.0f);
				}
				break;
			case "Stone":
				renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
				if (posX <= GameScript.nCols / 2 - 1){
					Functions.setSpriteAlpha(GameScript.pUpStone1, 1.0f);
				} else {
					Functions.setSpriteAlpha(GameScript.pUpStone2, 1.0f);
				}
				break;
        }
    }

    public void setSelected(bool boolSelected) {
        selected = boolSelected;
        SpriteRenderer renderer = this.GetComponent<SpriteRenderer>();

        if (selected) {
            Functions.highlightSprite(this.gameObject, "Normal");

            if (hidden){
                renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden2, typeof(Sprite)) as Sprite;
                return;
            }

            switch (element) {
                case "Neutral":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral2, typeof(Sprite)) as Sprite;
                    break;
                case "Fire":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileFire2, typeof(Sprite)) as Sprite;
                    break;
                case "Water":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileWater2, typeof(Sprite)) as Sprite;
                    break;
                case "Earth":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileEarth2, typeof(Sprite)) as Sprite;
                    break;
                default:
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden2, typeof(Sprite)) as Sprite;
                    break;
            }
        } else {
            Functions.highlightSprite(this.gameObject, "Normal");

            if (hidden) {
                renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden, typeof(Sprite)) as Sprite;
                return;
            }

            switch (element) {
                case "Neutral":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
                    break;
                case "Fire":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileFire, typeof(Sprite)) as Sprite;
                    break;
                case "Water":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileWater, typeof(Sprite)) as Sprite;
                    break;
                case "Earth":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileEarth, typeof(Sprite)) as Sprite;
                    break;
                default:
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden, typeof(Sprite)) as Sprite;
                    break;
            }
        }
    }

    public void setSuperSelected(bool boolSuperSelected) {
        if (GameScript.selectedTile != null) {
            GameScript.selectedTile.superDeselect();
        }

        SpriteRenderer renderer = this.GetComponent<SpriteRenderer>();
        
        GameScript.selectedTile = this;

        superSelected = boolSuperSelected;

        if (superSelected) {
            if (GameScript.playerTurn == 1)
                Functions.highlightSprite(this.gameObject, "Red");
            else
                Functions.highlightSprite(this.gameObject, "Green");
        } else {
            Functions.highlightSprite(this.gameObject, "Normal");

            if (hidden) {
                renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden, typeof(Sprite)) as Sprite;
                return;
            }

            switch (element) {
                case "Neutral":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
                    break;
                case "Fire":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileFire, typeof(Sprite)) as Sprite;
                    break;
                case "Water":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileWater, typeof(Sprite)) as Sprite;
                    break;
                case "Earth":
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileEarth, typeof(Sprite)) as Sprite;
                    break;
                default:
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden, typeof(Sprite)) as Sprite;
                    break;
            }
        }
    }

    public void superDeselect() {
        if (GameScript.selectedTile != null) {
            GameScript.selectedTile.superSelected = false;

            SpriteRenderer renderer = this.GetComponent<SpriteRenderer>();


            if (GameScript.selectedTile.selected) {
                Functions.highlightSprite(this.gameObject, "Normal");

                if (hidden) {
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden2, typeof(Sprite)) as Sprite;
                    return;
                }

                switch (element) {
                    case "Neutral":
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral2, typeof(Sprite)) as Sprite;
                        break;
                    case "Fire":
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileFire2, typeof(Sprite)) as Sprite;
                        break;
                    case "Water":
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileWater2, typeof(Sprite)) as Sprite;
                        break;
                    case "Earth":
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileEarth2, typeof(Sprite)) as Sprite;
                        break;
                    default:
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden2, typeof(Sprite)) as Sprite;
                        break;
                }
            } else {
                Functions.highlightSprite(this.gameObject, "Normal");
                if (hidden) {
                    renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden, typeof(Sprite)) as Sprite;
                    return;
                }
                switch (element) {
                    case "Neutral":
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileNeutral, typeof(Sprite)) as Sprite;
                        break;
                    case "Fire":
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileFire, typeof(Sprite)) as Sprite;
                        break;
                    case "Water":
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileWater, typeof(Sprite)) as Sprite;
                        break;
                    case "Earth":
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileEarth, typeof(Sprite)) as Sprite;
                        break;
                    default:
                        renderer.sprite = (Sprite)Resources.Load(Paths.tileHidden, typeof(Sprite)) as Sprite;
                        break;
                }
            }
        }
    }

    public void setTransition() {
        trans = true;
    }
}
